=== debian/control ===
Source: liburing
Section: libs
Priority: optional
Maintainer: Liu Changcheng <changcheng.liu@intel.com>
Build-Depends:
  debhelper-compat (= 13)
Standards-Version: 4.1.4
Homepage: https://git.kernel.dk/cgit/liburing/tree/README
Vcs-Git: https://git.kernel.dk/liburing
Vcs-Browser: https://git.kernel.dk/cgit/liburing/

Package: liburing2
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: userspace library for using io_uring
 io_uring is kernel feature to improve development
 The newese Linux IO interface, io_uring could improve
 system performance a lot. liburing is the userpace
 library to use io_uring feature.
 .
 This package contains the shared library.

Package: liburing-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends:
  ${misc:Depends},
  liburing2 (= ${binary:Version}),
  linux-libc-dev (>= 5.1)
Description: userspace library for using io_uring
 io_uring is kernel feature to improve development
 The newese Linux IO interface, io_uring could improve
 system performance a lot. liburing is the userpace
 library to use io_uring feature.
 .
 This package contains the static library and the header files.
